<template>
  <v-dialog
    v-model="dialog"
    width="30em"
  >
    <v-card class="pa-5">
      <v-card-title>Escanear Cartão</v-card-title>
      <formulary
        :success-msg="(model) => 'Success'"
        :msg-timeout="1000"
        submit-label="Associar"
        :submit="associate"
      >
        <v-text-field
          v-mask="'####-#'"
          :rules="[vRequired('Código')]"
          label="Código"
          v-model="code"
         />      </formulary>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import Vue from 'vue'

import associateCardMutation from '@/gql/AssociateCard.gql'

import vRequired from '@/validators/required'

import Formulary from '@/components/Formulary.vue'

export default Vue.extend({
  name: 'CardScannerDialog',
  components: { Formulary },
  props: {
    value: { type: Boolean, required: true },
    id: { type: String, default: null }
  },
  computed: {
    dialog: {
      get (): boolean {
        return this.value
      },
      set (v: boolean) {
        this.$emit('input', v)
      }
    }
  },
  data () {
    return {
      code: null,

      vRequired
    }
  },

  methods: {
    async associate () {
      await this.$apollo.mutate({
        mutation: associateCardMutation,
        variables: {
          personId: this.id,
          code: this.code
        }
      })
      setTimeout(() => (this.dialog = false), 1000)
    }
  }
})
</script>
